/*
btunlock.c Version 0.1.0  Btree insert record
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* return code 0 is good unlock */
/* return code 1 is lock status changed */
/* Database status was LOCK. */
/* It is now NOLOCK and the database has been */
/* unlocked. */
/* return code 4 is lock error */

#include <bthash.h>

int btunlock(bthdr)
btreefmt *bthdr;
   {
   int oldlock;
   int lockrslt;
   lockrslt = lockf(bthdr->hndl,F_ULOCK,0);
   if (lockrslt < 0)
      {
      fprintf(stderr,"btunlock: error "
	 "unlocking %s\n",
         bthdr->dbname);
      perror("Unlock error");
      return(BTUNLOCK4);
      }
   oldlock = bthdr->lock;
   bthdr->lock = NOLOCK;
   if (oldlock == LOCK)
      return(BTUNLOCK1);
   else return(UNLOCKGOOD);
   } /* btunlock */
