/*
hputptr.c Version 0.1.0  Hash write database block
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* This routine was designed to write */
/* hshhdr->freestk to disk. */
/* However, it is generalized to write */
/* any pointer. */
/* The output buffer is passed as a */
/* by-value parameter */

#include <bthash.h>

void hputptr(hshhdr,ofst,ptr)
hashfmt *hshhdr;
off_t ofst;
off_t ptr;
   {
   int wrtlen;
   off_t loc;
   unsigned char *p;
   hshhdr->reason = 0;
   loc = hseek(hshhdr,ofst);
   if (hshhdr->reason) return;
   p = (unsigned char *) &ptr;
   wrtlen = write(hshhdr->hndl,p,sizeof(off_t));
   if (wrtlen == sizeof(off_t))
      return;
   else if (wrtlen < 0)
      {
      fprintf(stderr,"Errno %d\n", errno);
      perror("Write error");
      hshhdr->reason = SYS_ERR + errno;;
      return;
      } /* write error */
   else
      {
      fprintf(stderr,"Write error (wrtlen %d)", wrtlen);
      hshhdr->reason = HASH_ERR + 801;
      return;
      } /* write error */
   } /* hputptr */
