/*
hupdt.c Version 0.1.0  Hash update record
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* return code 0 is good update */
/* return code 1 is record not found */
/* return code 3 is lock pending prior to update */
/* return code 4 is lock error */

#include <bthash.h>

int hupdt(hshhdr,rcd)
hashfmt *hshhdr;
unsigned char *rcd;
   {
   off_t ofst;
   int sigrslt;
   int hgrslt;
   int lockrslt;
   unsigned char *p,*q,*r;
   unsigned char *buf;
   hshhdr->reason = 0;
   sigrslt = strcmp(hshhdr->signature,H_SIGNATURE);
   if (sigrslt)
      {
      fprintf(stderr,"hupdt: non-hash "
	 "update\n");
      hshhdr->reason = HASH_ERR + 2203;
      return(HASH_ERR + 2203);
      } /* not a btree header */
   lockrslt = lockf(hshhdr->hndl,F_TEST,0);
   if (lockrslt < 0)
      {
      return(UPDTLOCK3);
      } /* can't update when file is locked */
   lockrslt = lockf(hshhdr->hndl,F_TLOCK,0);
   if (lockrslt < 0)
      {
      fprintf(stderr,"hupdt: lock error on %s\n",
	 hshhdr->dbname);
      perror("Lock error");
      return(UPDTLOCK4);
      } /* can't update if lock error */
   buf = (unsigned char *) malloc(hshhdr->rcdlen + 16);
   if (buf == NULL)
      {
      fprintf(stderr,"hupdt: out of memory\n");
      return(HASH_ERR + 2201);
      } /* out of mem */
   p = (unsigned char *) rcd + hshhdr->keyofst;
   hgrslt = hget(hshhdr,p,buf);
   free(buf);
   if (hgrslt) return(hgrslt);
   p = (unsigned char *)
      hshhdr->node + hshhdr->rcdhdr;
   q = (unsigned char *) p + hshhdr->rcdlen;
   r = (unsigned char *) rcd;
   while (p < q) *p++ = *r++;
   ofst = (off_t) hshhdr->ofst;
   hputblk(hshhdr,ofst,hshhdr->node);
   if (hshhdr->reason) return(HASH_ERR + 2202);
   p = (unsigned char *) hshhdr->node;
   q = (unsigned char *) hshhdr->node + hshhdr->rcdnode;
   while (p < q) *p++ = '\0';
   hshhdr->ofst = (off_t) 0;
   if (hshhdr->lock != LOCK)
      {
      lockrslt = lockf(hshhdr->hndl,F_ULOCK,0);
      if (lockrslt < 0)
         {
         fprintf(stderr,"hupdt: error unlocking "
            "%s after insertion\n",
            hshhdr->dbname);
         perror("Unlock error");
         hshhdr->reason  = SYS_ERR + errno;
	 return(SYS_ERR + errno);
         }
      } /* if no lock during open, unlock */
   return(UPDTGOOD);
   } /* hupdt */
